SpecializationUtil.registerSpecialization("advancedFillAutoAimTargetNode", "advancedFillAutoAimTargetNode", g_currentModDirectory.."advancedFillAutoAimTargetNode.lua")

advancedFillAutoAimTargetNode_Register = {};

function advancedFillAutoAimTargetNode_Register:loadMap(name)
	local hasTrailerSpeci = false;
	local hasFillableSpeci = false;
	
	if self.firstRun == nil then
		self.firstRun = false;
		print("--- loading advancedFillAutoAimTargetNode Version 1.0 by mjk ---")
		
		for k, v in pairs(VehicleTypeUtil.vehicleTypes) do
			if v ~= nil then
				local allowInsertion = true;
			
				for i = 1, table.maxn(v.specializations) do			
					local vs = v.specializations[i];
					--Needed Specialization 1
					if vs == SpecializationUtil.getSpecialization("trailer") then
						hasTrailerSpeci = true;
					end;
					--Needed Specialization 2
					if vs == SpecializationUtil.getSpecialization("fillable") then
						hasFillableSpeci = true;
					end;
					--Not allowed Specializations
					if vs == SpecializationUtil.getSpecialization("selfPropelledMixerWagon") or
					   vs == SpecializationUtil.getSpecialization("mixerWagon") or
					   vs == SpecializationUtil.getSpecialization("strawBlower") or
					   vs == SpecializationUtil.getSpecialization("mower") then
						allowInsertion = false;
					end;
				end;
				
				--Add Specialization
				if hasTrailerSpeci and hasFillableSpeci then
					local v_name_string = v.name 
					local point_location = string.find(v_name_string, ".", nil, true)
					if point_location ~= nil then
						local _name = string.sub(v_name_string, 1, point_location-1);
						if rawget(SpecializationUtil.specializations, string.format("%s.advancedFillAutoAimTargetNode", _name)) ~= nil then
							allowInsertion = false;								
						end;							
					end;
					if allowInsertion then	
						--Add Specialization to the Mod
						table.insert(v.specializations, SpecializationUtil.getSpecialization("advancedFillAutoAimTargetNode"));
						 print("  advancedFillAutoAimTargetNode was inserted on " .. k);
					end;	
				end;
			end;
			
			hasTrailerSpeci = false;
			hasFillableSpeci = false;
		end;
	end;
end;

function advancedFillAutoAimTargetNode_Register:deleteMap()
  
end;

function advancedFillAutoAimTargetNode_Register:keyEvent(unicode, sym, modifier, isDown)

end;

function advancedFillAutoAimTargetNode_Register:mouseEvent(posX, posY, isDown, isUp, button)

end;

function advancedFillAutoAimTargetNode_Register:update(dt)
	
end;

function advancedFillAutoAimTargetNode_Register:draw()
  
end;

addModEventListener(advancedFillAutoAimTargetNode_Register);